/* 
 * matrix.c --- written by yasuko matsubara 2012.6.7
 */



#include        <stdio.h>
#include        <string.h>
#include        <stdlib.h>
#include        <math.h>
#include	"nrutil.h"
#include 	"tool.h"

#define   BUFSIZE            256

void outerproduct(double *a, double *b, int na, int nb, double **ans){
  int i,j;
  for(i=0;i<na;i++)
    for(j=0;j<nb;j++)
      ans[i][j]=a[i]*b[j];

}
double multVV(double *a, double *b, int n){
  int i,j;
  double sum=0.0;
  for(i=0;i<n;i++)
    sum+= a[i]*b[i];
  return sum;
}
void multVM(double *V, double **M, int ncol, int nrow, double *ans){
  int i,j;
  for(i=0;i<ncol;i++){
    double sum=0.0;
    for(j=0;j<nrow;j++)
      sum+= V[j]*M[i][j];
    ans[i]=sum;
  }//i
}
void copyMM(double **A, int ncol, int nrow, double **Mans){
  int i,j;
  for(i=0;i<ncol;i++)
    for(j=0;j<nrow;j++)
      Mans[i][j] = A[i][j];
}
void plusVV(double *A, double *B, int n, double *Vans){
  int i,j;
  for(i=0;i<n;i++)
      Vans[i] = A[i]+B[i];
}

void plusMM(double **A, double **B, int ncol, int nrow, double **Mans){
  int i,j;
  for(i=0;i<ncol;i++)
    for(j=0;j<nrow;j++)
      Mans[i][j] = A[i][j]+B[i][j];
}
void minusMM(double **A, double **B, int ncol, int nrow, double **Mans){
  int i,j;
  for(i=0;i<ncol;i++)
    for(j=0;j<nrow;j++)
      Mans[i][j] = A[i][j]-B[i][j];
}

void multNV(double norm, double *V, int n, double *Vans){
  int i,j;
  for(i=0;i<n;i++)
      Vans[i] = norm*V[i];
}
void multNM(double norm, double **M, int ncol, int nrow, double **Mans){
  int i,j;
  for(i=0;i<ncol;i++)
    for(j=0;j<nrow;j++)
      Mans[i][j] = norm*M[i][j];
}
void multMM(double **A, double **B, int ncol, int nrow, double **Mans){
  int i,j, k;
  for(i=0;i<ncol;i++)
    for(j=0;j<ncol;j++){
      double sum = 0.0;
      for(k=0;k<nrow;k++)
        sum += A[i][k]*B[k][j];
      Mans[i][j] = sum;
    }//j
}

void identity(double **M, int x, double val){
  int i,j;
  for(i=0;i<x;i++){
    for(j=0;j<x;j++)
      if(i==j)
        M[i][j]=val;
      else
        M[i][j]=0.0;
  }//i
}
void zeros(double **M, int x, int y){
  int i,j;
  for(i=0;i<x;i++)
    for(j=0;j<y;j++)
        M[i][j]=0.0;
}
void zerosV(double *V, int x){
  int i,j;
  for(i=0;i<x;i++)
        V[i]=0.0;
}
void printMatrix(FILE *fp, double **M, int x, int y){
  int i,j;
  fprintf(fp, "----------\n");
  for(i=0;i<x;i++){
    for(j=0;j<y;j++)
      fprintf(fp, "%.8f ", M[i][j]);
    fprintf(fp, "\n");
  }//i
}
void printVector(FILE *fp, double *V, int x){
  int i,j;
  fprintf(fp, "----------\n");
  for(i=0;i<x;i++)
    fprintf(fp, "%.8f ", V[i]);
  fprintf(fp, "\n");
}

